function [flag_error,result00,count0,Pu_opt,eta_opt,DL,UL] =op(eta_opt,h_AU,M,B_m2,Q,G0,gama,noise,noise1,b_ref,b1_ref,H_n,user,Pt,antenna_BS)

count0 = 1;
DL=0;UL=0;
result00 = [0;100];

while(1)
    count=1;
    result = [0;100];
    b_ref =zeros([user,1]);
    b1_ref =zeros([user,1]);
    while(1)
    
      % cvx_clear
       cvx_begin sdp
    
            variable Pu(antenna_BS,antenna_BS,user) complex hermitian semidefinite
            expression a(user,1);
            expression b(user,1);
            expression mid_a(antenna_BS,antenna_BS);
            expression mid_b(antenna_BS,antenna_BS);
            expression mid_b0(antenna_BS,antenna_BS);
            expression mid_1(antenna_BS,antenna_BS);
            for i=1:M
                G0(:,:,i)=eta_opt(1,i).*B_m2(:,:,i);
            end
            
            for i=1:user
                mid_a=zeros(antenna_BS,antenna_BS);
                for j=i:user
                 a(i) = a(i)+real(trace(h_AU(:,i)*h_AU(:,i)'*Pu(:,:,j)));
                end

                for m=1:M
                    mid_a=mid_a+H_n(:,m,i)*eta_opt(1,m)*H_n(:,m,i)'*sum(Pu,3);
                end
                 a(i) =a(i)+real(trace(mid_a));
            end
            
            for i=1:user-1
                mid_b=zeros(antenna_BS,antenna_BS);
                for j=i+1:user
                 b(i) = b(i)+real(trace(h_AU(:,i)*h_AU(:,i)'*Pu(:,:,j)));
                end

                for m=1:M
                    mid_b=mid_b+H_n(:,m,i)*eta_opt(1,m)*H_n(:,m,i)'*sum(Pu,3);
                end
                b(i) =b(i)+real(trace(mid_b));
            end

            for m=1:M
                mid_b0=mid_b0+H_n(:,m,user)*eta_opt(1,m)*H_n(:,m,user)'*sum(Pu,3);
            end 
            b(user,1)=real(trace(mid_b0));
                 
                    
            maximize 0.1*log(1+Q*(real(trace(sum(G0,3)*sum(Pu,3))))/noise1)/log(2)/Q+0.9*((sum(log(noise+a)./log(2))))- 0.9*(  (  sum(  (log(noise+b_ref)./log(2))   +   (b-b_ref)./(log(2*(noise+b_ref)))  )  )  )
           % maximize 0.9*((sum(log(noise+a)./log(2))))-0.9*((sum((log(noise+b_ref)./log(2))+(b-b_ref)./(log(2*(noise+b_ref))))))
             % minimize -0.1*log(1+Q*(real(trace(sum(G0,3)*sum(Pu,3))))/noise1)/log(2)/Q
            subject to
            
  % sumrate 
            real(trace(sum(Pu,3))) <= Pt;
               
            for m = 1:user
                Pu(:,:,m) >= 0;
            end
                %Qos+SIC
            for m = 1:user     
                for i=m:user
                    mid_1=zeros(antenna_BS,antenna_BS);
                    for j=1:M
                        mid_1=mid_1+H_n(:,j,i)*eta_opt(1,j)*H_n(:,j,i)'*sum(Pu,3);
                    end
                    real(trace(h_AU(:,i)*h_AU(:,i)'*Pu(:,:,m)))/gama-real(trace(h_AU(:,i)*h_AU(:,i)'*sum(Pu(:,:,m+1:user),3)))-real(trace(mid_1))-noise >= 0;
                end      
            end
       %channel order
            for m = 1:user
                for n = 1:(user-1)
                   real(trace(h_AU(:,m)*h_AU(:,m)'*Pu(:,:,n))) >= real(trace(h_AU(:,m)*h_AU(:,m)'*Pu(:,:,n+1)));
                end
            end
                
    cvx_end
     
            if (cvx_optval == -Inf)
                flag_error = 1;
                break;
            else
                if (cvx_optval == +Inf)
                    flag_error = 1;
                    break;
                else
                    if (isnan(cvx_optval) == 1)
                        flag_error = 1;
                        break;
                    else
                        flag_error = 0;
                    end
                end
            end

            if mod(count,2) == 0
                result(2,1) =0.1*log(1+Q*(real(trace(sum(G0,3)*sum(Pu,3))))/noise1)/log(2)/Q+0.9*((sum(log(noise+a)./log(2))))-0.9*((sum((log(noise+b_ref)./log(2))+(b-b_ref)./(log(2*(noise+b_ref))))));
                % result(2,1) = 0.9*((sum(log(noise+a)./log(2))))-0.9*((sum((log(noise+b_ref)./log(2))+(b-b_ref)./(log(2*(noise+b_ref))))));
                else
                result(1,1) =0.1*log(1+Q*(real(trace(sum(G0,3)*sum(Pu,3))))/noise1)/log(2)/Q+0.9*((sum(log(noise+a)./log(2))))-0.9*((sum((log(noise+b_ref)./log(2))+(b-b_ref)./(log(2*(noise+b_ref))))));
                % result(1,1) = 0.9*((sum(log(noise+a)./log(2))))-0.9*((sum((log(noise+b_ref)./log(2))+(b-b_ref)./(log(2*(noise+b_ref))))));
            end

            b_ref = b;    

            if (abs(result(2,1)-result(1,1)) <= 0.01)
                break
            else
                count = count+1;
                if(count > 20)
                    flag_error=1;
                    break
                end
            end          
    end
    
   Pu_opt = Pu; 

    if flag_error == 0
        DL=0;UL=0;
        count=1;
        result1 = [0;100];
        while(1)
      cvx_begin 
            variable eta(1,M)
           
            expression G1(antenna_BS,antenna_BS,M) ;
            expression a1(user,1);
            expression b1(user,1);
            expression mid_a1(antenna_BS,antenna_BS);
            expression mid_b1(antenna_BS,antenna_BS);
            expression mid_b10(antenna_BS,antenna_BS);
            expression mid_2(antenna_BS,antenna_BS);

            for i=1:M
                G1(:,:,i)=eta(1,i).*B_m2(:,:,i);
            end


            for i=1:user
                mid_a1=zeros(antenna_BS,antenna_BS);
            
                for j=i:user
                    a1(i) = a1(i)+real(trace(h_AU(:,i)*h_AU(:,i)'*Pu_opt(:,:,j)));
                end 
                
                for m=1:M
                    mid_a1=mid_a1+H_n(:,m,i)*eta(1,m)*H_n(:,m,i)'*sum(Pu_opt,3);
                end
                a1(i) =a1(i)+real(trace(mid_a1));
            end
            
            for i=1:user-1
                mid_b1=zeros(antenna_BS,antenna_BS);

                for j=i+1:user
                 b1(i) = b1(i)+real(trace(h_AU(:,i)*h_AU(:,i)'*Pu_opt(:,:,j)));
                end

                for m=1:M
                    mid_b1=mid_b1+H_n(:,m,i)*eta(1,m)*H_n(:,m,i)'*sum(Pu_opt,3);
                end

                b1(i) =b1(i)+real(trace(mid_b1));
            end

            for m=1:M
                mid_b10=mid_b10+H_n(:,m,user)*eta(1,m)*H_n(:,m,user)'*sum(Pu_opt,3);
            end   
            b1(user,1)=real(trace(mid_b10));
  
            maximize 0.1*log(1+Q*(real(trace(sum(G1,3)*sum(Pu_opt,3))))/noise1)/log(2)/Q+0.9*((sum(log(noise+a1)./log(2))))-0.9*((sum((log(noise+b1_ref)./log(2))+(b1-b1_ref)./(log(2*(noise+b1_ref))))))
% maximize 0.9*((sum(log(noise+a1)./log(2))))-0.9*((sum((log(noise+b1_ref)./log(2))+(b1-b1_ref)./(log(2*(noise+b1_ref))))))
% minimize -0.1*log(1+Q*(real(trace(sum(G1,3)*sum(Pu_opt,3))))/noise1)/log(2)/Q
            subject to
            


            for m=1:M
                0.1 <= eta(1,m) ;
            end
            
            for m=1:M
                 eta(1,m) <= 1;
            end

%             %Qos+SIC
%             for m = 1:user     
%                 for i=m:user
%                 real(trace(h_bu1(i,:)*h_bu1(i,:)'*Pu_opt(:,:,m)))/gama-real(trace(h_bu1(i,:)*h_bu1(i,:)'*sum(Pu_opt(:,:,m+1:user),3)))-real(trace(H_n(:,:,i)*sum(Pu_opt,3)*H_n(:,:,i)'*eta1))-noise >= 0;
%                 end      
%             end
        %Qos+SIC
            for m = 1:user     
                for i=m:user
                    mid_2=0;
                    for j=1:M
                        mid_2=mid_2+H_n(:,j,i)*eta(1,j)*H_n(:,j,i)'*sum(Pu_opt,3);
                    end
                real(trace(h_AU(:,i)*h_AU(:,i)'*Pu_opt(:,:,m)))/gama-real(trace(h_AU(:,i)*h_AU(:,i)'*sum(Pu_opt(:,:,m+1:user),3)))-real(trace(mid_2))-noise >= 0;
                end      
            end
       
      
     cvx_end
 
         if (cvx_optval == -Inf)
    	    flag_error = 1;
            break
        else
            if (cvx_optval == +Inf)
                flag_error = 1;
                break
            else
                if (isnan(cvx_optval) == 1)
                    flag_error = 1;
                    break
                else
                    flag_error = 0;
                end
            end
         end
         
        if mod(count,2) == 0
                % result(2,1) =0.9*((sum(log(noise+a1)./log(2))))-0.9*((sum((log(noise+b1_ref)./log(2))+(b1-b1_ref)./(log(2*(noise+b1_ref))))));
           result1(2,1) =0.1*log(1+Q*(real(trace(sum(G1,3)*sum(Pu_opt,3))))/noise1)/log(2)/Q+0.9*((sum(log(noise+a1)./log(2))))-0.9*((sum((log(noise+b1_ref)./log(2))+(b1-b1_ref)./(log(2*(noise+b1_ref))))));
      	    else
           result1(1,1) =0.1*log(1+Q*(real(trace(sum(G1,3)*sum(Pu_opt,3))))/noise1)/log(2)/Q+0.9*((sum(log(noise+a1)./log(2))))-0.9*((sum((log(noise+b1_ref)./log(2))+(b1-b1_ref)./(log(2*(noise+b1_ref))))));
         % result(1,1) =0.9*((sum(log(noise+a1)./log(2))))-0.9*( (sum((log(noise+b1_ref)./log(2))+(b1-b1_ref)./(log(2*(noise+b1_ref))))));
        end
        
        b1_ref = b1;             

            if (abs(result1(2,1)-result1(1,1)) <= 0.01)        
                break
	        else
                count = count+1;
                if(count > 20)
                        flag_error=1;
                        break
                end
            end

        end

         for m=1:M
            eta_opt(1,m)=eta(1,m);
         end


    end

    if flag_error == 1
         Pu_opt = 0;
         DL=0;
         UL=0;
         break
    end
   
   % if mod(count0,2) == 0
          %  result(2,1) =0.1*log(1+Q*(real(trace(sum(G1,3)*sum(Pu_opt,3))))/noise1)/log(2)/Q;%+0.9*((sum(log(noise+a1)./log(2))))-0.9*((sum((log(noise+b1_ref)./log(2))+(b1-b1_ref)./(log(2*(noise+b1_ref))))));
       result00(1,1) =max(result);
   % else
       result00(2,1) =max(result1);
       % result(1,1) =0.9*((sum(log(noise+a1)./log(2))))-0.9*( (sum((log(noise+b1_ref)./log(2))+(b1-b1_ref)./(log(2*(noise+b1_ref))))));
   % end
                                                                       
    if (abs(result00(2,1)-result00(1,1)) <= 0.01)        
        break
	else
        count0 = count0+1;
        if(count0 > 20)
                flag_error=1;
                break
        end
    end
   
end


if flag_error == 1
    Pu_opt = 0;
    DL=0;
    UL=0;
end


if flag_error == 0

G2=zeros(antenna_BS,antenna_BS,M);
mid_a2=zeros(antenna_BS,antenna_BS);
mid_b2=zeros(antenna_BS,antenna_BS);
mid_b20=zeros(antenna_BS,antenna_BS);
% eta_opt=zeros(1,M);
    for m=1:M
        G2(:,:,m)=eta_opt(1,m).*B_m2(:,:,m);        
    end
            
    
        a2=zeros(user,1);
        b2=zeros(user,1);
           
     for i=1:user
        for j=i:user
         a2(i) = a2(i)+real(trace(h_AU(:,i)*h_AU(:,i)'*Pu_opt(:,:,j)));
        end 
        mid_a2=zeros(antenna_BS,antenna_BS);
            for m=1:M
                mid_a2=mid_a2+H_n(:,m,i)*eta_opt(:,m)*H_n(:,m,i)'*sum(Pu_opt,3);
            end
       a2(i) =a2(i)+real(trace(mid_a2));
    end
    % te=real(trace(h_AU(:,2)*h_AU(:,2)'*Pu_opt(:,:,2)));
    for i=1:user-1
        mid_b2=zeros(antenna_BS,antenna_BS);
        for j=i+1:user
         b2(i) = b2(i)+real(trace(h_AU(:,i)*h_AU(:,i)'*Pu_opt(:,:,j)));
        end

        for m=1:M
            mid_b2=mid_b2+H_n(:,m,i)*eta_opt(:,m)*H_n(:,m,i)'*sum(Pu_opt,3);
        end
  b2(i) =b2(i)+real(trace(mid_b2));
    end
    
    for m=1:M
        mid_b20=mid_b20+H_n(:,m,user)*eta_opt(:,m)*H_n(:,m,user)'*sum(Pu_opt,3);
    end
b2(user,1)=real(trace(mid_b20));

UL=log(1+Q*(real(trace(sum(G2,3)*sum(Pu_opt,3))))/noise1) /log(2) /Q; 
DL=((sum(log(noise+a2)./log(2))))-((sum(log(noise+b2)./log(2))));          

end



    


