function [flag_error,result00,count0,Pu_opt,eta_opt,DL,UL] =op(eta_opt,M,B_m2,Q,G0,gama,noise,noise1,b_ref,b1_ref,H_n,user,Pt,antenna_BS)

DL=0;UL=0;
result00 = [0;100];
count0 = 1; 

while(1)

    count = 1;
    result = [0;100];
    b_ref =zeros([user,1]);
    while(1)

      % cvx_clear
       cvx_begin sdp
    
            variable Pu(antenna_BS,antenna_BS,user) complex hermitian semidefinite
            expression a(user,1);
            expression b(user,1);
            expression mid_a(antenna_BS,antenna_BS);
            expression mid_b(antenna_BS,antenna_BS);
            expression mid_1(antenna_BS,antenna_BS);
            expression mid_2(antenna_BS,antenna_BS);
            expression mid_3(antenna_BS,antenna_BS);
            expression mid_4(antenna_BS,antenna_BS);
      
            for i=1:M
                G0(:,:,i)=eta_opt(1,1,i).*B_m2(:,:,i);
            end
      
            for i=1:user
                for j=i:user
                    mid_a=zeros(antenna_BS,antenna_BS);
                    for m=1:M
                        mid_a=mid_a+H_n(:,:,i,m)*eta_opt(:,:,m)*H_n(:,:,i,m)'*Pu(:,:,j);
                    end
                 a(i) = a(i)+real(trace(mid_a));
                end
            end
            
            for i=1:user-1
                for j=i+1:user
                    mid_b=zeros(antenna_BS,antenna_BS);
                    for m=1:M
                        mid_b=mid_b+H_n(:,:,i,m)*eta_opt(:,:,m)*H_n(:,:,i,m)'*Pu(:,:,j);
                    end
                 b(i) = b(i)+real(trace(mid_b));
                end
            end
            b(user,1)=0;
        
  %sumrate 
            maximize 0.1*log(1+Q*(real(trace(sum(G0,3)*sum(Pu,3))))/noise1)/log(2)/Q+0.9*((sum(log(noise+a)./log(2))))-0.9*((sum((log(noise+b_ref)./log(2))+(b-b_ref)./(log(2*(noise+b_ref))))))

            subject to 
  %Power 
            real(trace(sum(Pu,3))) <= Pt;
               
            for m = 1:user
                Pu(:,:,m) >= 0;
            end
  %Qos+SIC
            for m = 1:user    
                for i=m:user
                    mid_1=zeros(antenna_BS,antenna_BS);
                    mid_2=zeros(antenna_BS,antenna_BS);
                    for j=1:M
                        mid_1=mid_1+H_n(:,:,i,j)*eta_opt(:,:,j)*H_n(:,:,i,j)'*Pu(:,:,m);
                        mid_2=mid_2+H_n(:,:,i,j)*eta_opt(:,:,j)*H_n(:,:,i,j)'*sum(Pu(:,:,m+1:user),3);
                    end
                real(trace(mid_1))/gama-real(trace(mid_2))-noise >= 0;
                
                end      
            end
   %channel order
            for m = 1:user
                for n = 1:(user-1)
                    mid_3=zeros(antenna_BS,antenna_BS);
                    mid_4=zeros(antenna_BS,antenna_BS);
                    for j=1:M
                        mid_3=mid_3+H_n(:,:,m,j)*eta_opt(:,:,j)*H_n(:,:,m,j)'*Pu(:,:,n);
                        mid_4=mid_4+H_n(:,:,m,j)*eta_opt(:,:,j)*H_n(:,:,m,j)'*Pu(:,:,n+1);
                    end

                   real(trace(mid_3)) >= real(trace(mid_4));
                end
            end
                
     cvx_end
 
        if (cvx_optval == -Inf)
	        flag_error = 1;
            break;
        else
           if (cvx_optval == +Inf)
               flag_error = 1;
               break;
           else
               if (isnan(cvx_optval) == 1)
                   flag_error = 1;
                   break;
               else
                   flag_error = 0;
               end
           end
        end
         
        if mod(count,2) == 0
            result(2,1) =0.1*log(1+Q*(real(trace(sum(G0,3)*sum(Pu,3))))/noise1)/log(2)/Q+0.9*((sum(log(noise+a)./log(2))))-0.9*((sum((log(noise+b_ref)./log(2))+(b-b_ref)./(log(2*(noise+b_ref))))));
            else
            result(1,1) =0.1*log(1+Q*(real(trace(sum(G0,3)*sum(Pu,3))))/noise1)/log(2)/Q+0.9*((sum(log(noise+a)./log(2))))-0.9*( (sum((log(noise+b_ref)./log(2))+(b-b_ref)./(log(2*(noise+b_ref))))));
        end
              b_ref = b;                                                                      
        if (abs(result(2,1)-result(1,1)) <= 0.01)
            break
        else
            count = count+1;
            if(count > 10 )
                flag_error = 1;
                break
            end
        end   

    end
    
    Pu_opt = Pu; 

if flag_error == 0
    DL=0;UL=0;
    count=1;
    result1 = [0;100];
    b1_ref =zeros([user,1]);
    while(1)
    % while(1)
    %     cvx_clear
        cvx_begin 
        
                variable eta(2,2,M)  complex hermitian semidefinite

                expression G1(antenna_BS,antenna_BS,M);
                expression a1(user,1);
                expression b1(user,1);
                expression mid_a1(antenna_BS,antenna_BS);
                expression mid_b1(antenna_BS,antenna_BS);
                expression mid_5(antenna_BS,antenna_BS);
                expression mid_6(antenna_BS,antenna_BS);
                expression mid_7(antenna_BS,antenna_BS);
                expression mid_8(antenna_BS,antenna_BS);

                for i=1:M
                    G1(:,:,i)=eta(1,1,i).*B_m2(:,:,i);
                end

                 for i=1:user
                    for j=i:user
                        mid_a1=zeros(antenna_BS,antenna_BS);
                        for m=1:M
                            mid_a1=mid_a1+H_n(:,:,i,m)*eta(:,:,m)*H_n(:,:,i,m)'*Pu_opt(:,:,j);
                        end
                     a1(i) = a1(i)+real(trace(mid_a1));
                    end
                end
                
                for i=1:user-1
                    for j=i+1:user
                        mid_b1=zeros(antenna_BS,antenna_BS);
                        for m=1:M
                            mid_b1=mid_b1+H_n(:,:,i,m)*eta(:,:,m)*H_n(:,:,i,m)'*Pu_opt(:,:,j);
                        end
                     b1(i) = b1(i)+real(trace(mid_b1));
                    end
                end
                b1(user,1)=0;

                maximize 0.1*log(1+Q*(real(trace(sum(G1,3)*sum(Pu_opt,3))))/noise1)/log(2)/Q+0.9*((sum(log(noise+a1)./log(2))))-0.9*((sum((log(noise+b1_ref)./log(2))+(b1-b1_ref)./(log(2*(noise+b1_ref))))))
  
                subject to
               
                for m=1:M
                    eta(2,2,m) == 1;
                end

               for m=1:M
                    0 <= eta(1,1,m) ;
               end

               for m=1:M
                    eta(1,1,m) <= 1;
               end
                %Qos+SIC
                for m = 1:user    
                    for i=m:user
                        mid_5=zeros(antenna_BS,antenna_BS);
                        mid_6=zeros(antenna_BS,antenna_BS);
                        for j=1:M
                            mid_5=mid_5+H_n(:,:,i,j)*eta(:,:,j)*H_n(:,:,i,j)'*Pu_opt(:,:,m);
                            mid_6=mid_6+H_n(:,:,i,j)*eta(:,:,j)*H_n(:,:,i,j)'*sum(Pu_opt(:,:,m+1:user),3);
                        end
                    real(trace(mid_5))/gama-real(trace(mid_6))-noise >= 0;
                    end      
                end
           %channel order
                for m = 1:user
                    for n = 1:(user-1)
                        mid_7=zeros(antenna_BS,antenna_BS);
                        mid_8=zeros(antenna_BS,antenna_BS);
                        for j=1:M
                            mid_7=mid_7+H_n(:,:,m,j)*eta(:,:,j)*H_n(:,:,m,j)'*Pu_opt(:,:,n);
                            mid_8=mid_8+H_n(:,:,m,j)*eta(:,:,j)*H_n(:,:,m,j)'*Pu_opt(:,:,n+1);
                        end
                       real(trace(mid_7)) >= real(trace(mid_8));
                    end
                end
     cvx_end
         if (cvx_optval == -Inf)
                flag_error = 1;
                break
         else
                if (cvx_optval == +Inf)
                    flag_error = 1;
                    break
                else
                    if (isnan(cvx_optval) == 1)
                        flag_error = 1;
                        break
                    else
                        flag_error = 0;
                    end
                end
         end
    
        if mod(count,2) == 0
            result1(2,1) =0.1*log(1+Q*(real(trace(sum(G1,3)*sum(Pu_opt,3))))/noise1)/log(2)/Q+0.9*((sum(log(noise+a1)./log(2))))-0.9*((sum((log(noise+b1_ref)./log(2))+(b1-b1_ref)./(log(2*(noise+b1_ref))))));
            else
            result1(1,1) =0.1*log(1+Q*(real(trace(sum(G1,3)*sum(Pu_opt,3))))/noise1)/log(2)/Q+0.9*((sum(log(noise+a1)./log(2))))-0.9*( (sum((log(noise+b1_ref)./log(2))+(b1-b1_ref)./(log(2*(noise+b1_ref))))));
        end

        b1_ref = b1;    

        if (abs(result1(2,1)-result1(1,1)) <= 0.01)
            break
	    else
            count = count+1;
            if(count > 10 )
                flag_error = 1;
                break
            end
        end  
     
    end

    for m=1:M
    eta_opt(:,:,m)=eta(:,:,m);
    end

end


 if flag_error == 1
        Pu_opt = 0;
         DL=0;
         UL=0;
         break
 end

% if mod(count0,2) == 0
    result00(1,1) =max(result);
% else
    result00(2,1) =max(result1);
% end

    if (abs(result00(2,1)-result00(1,1)) <= 0.01)
        break
    else
        count0 = count0+1;
        if(count0 > 10 )
            flag_error = 1;
            break
        end
    end 
end

if flag_error == 1
        Pu_opt = 0;
         DL=0;
         UL=0;
end

if flag_error == 0
    
       G2=zeros(antenna_BS,antenna_BS,M);
       a2=zeros(user,1);
       b2=zeros(user,1);
       mid_a2=zeros(antenna_BS,antenna_BS);
       mid_b2=zeros(antenna_BS,antenna_BS);
   
        for m=1:M
            G2(:,:,m)=eta_opt(1,1,m).*B_m2(:,:,m);

        end

        for i=1:user
            for j=i:user
                mid_a2=zeros(antenna_BS,antenna_BS);
                for m=1:M
                    mid_a2=mid_a2+H_n(:,:,i,m)*eta_opt(:,:,m)*H_n(:,:,i,m)'*Pu_opt(:,:,j);
                end
             a2(i) = a2(i)+real(trace(mid_a2));
            end
        end
            
        for i=1:user-1
            for j=i+1:user
                mid_b2=zeros(antenna_BS,antenna_BS);
                for m=1:M
                    mid_b2=mid_b2+H_n(:,:,i,m)*eta_opt(:,:,m)*H_n(:,:,i,m)'*Pu_opt(:,:,j);
                end
             b2(i) = b2(i)+real(trace(mid_b2));
            end
        end
        b2(user,1)=0;

        DL=((sum(log(noise+a2)./log(2))))-((sum(log(noise+b2)./log(2))));          
        UL=log(1+Q*(real(trace(sum(G2,3)*sum(Pu_opt,3))))/noise1)/log(2)/Q; 
end


  
