clear all;
clc;

loop = 100;

antenna_BS = 4;
antenna_BD = 1;
antenna_user = 1;

user = 2; 
M = 20;
Q = 128;

Gama = 5;%legacy user Qos lower bound
gama = 10.^((Gama-30)/10);%dB

%channel noise + FD self-interference
%noise = 10^((-94-30)/10);
noise = 1;
% noise1=10^((-94-20-30)/10);%-0.001*abs( complex(sqrt(0.5)*randn(1,1),sqrt(0.5)*randn(1,1)) )^2;
noise1 = 10^((-94-30)/10)+10^((-90-30)/10);%-0.001*abs( complex(sqrt(0.5)*randn(1,1),sqrt(0.5)*randn(1,1)) )^2;

Power = 0:5:30;

final_result = zeros(4,length(Power));

% load('bd2'); load('bu2'); load('du2');
for p = 1:length(Power)
    Pt = 10.^((Power(p)-30)/10);%dB
    % M=M0(p);
    % user=user0(p);
    
    [bd2,bu2,du2]=channel(M,user);

    b_ref =zeros([user,1]);
    b1_ref =zeros([user,1]);
    for num=1:loop
        G0=zeros(antenna_BS,antenna_BS,M);  

        eta_opt=zeros(1,M);
        for m = 1:M
            eta_opt(:,m) = 0.5+1i*0.5;
        end
    
        h_AB = bd2(:,:,num)';
        h_AU = zeros(antenna_BS,user);
        h_BU = zeros(M,user);
    
        for i = 1:user
            h_AU(:,i) = bu2(i,:,num)';
        end     
          
        for i = 1:M
            h_BU(i,:) = du2(i,:,num);
            B_m1(:,:,i) = h_AB(:,i)*h_AB(:,i)';
            B_m2(:,:,i) = B_m1(:,:,i)*B_m1(:,:,i)';
        end 
     
        H_n = zeros(antenna_BS,M,user);
        for i = 1 : M
            for k = 1:user 
                H_n(:,i,k) = [h_AB(:,i)*h_BU(i,k)]; 
            end
        end
    
             
        flag_error = 0;

        [flag_error,result00,count0,Pu_opt,eta_opt,DL,UL] =op(eta_opt,h_AU,M,B_m2,Q,G0,gama,noise,noise1,b_ref,b1_ref,H_n,user,Pt,antenna_BS);
    
        % for i=1:M
        %    u_m(:,:,i) =B_m1(:,:,i)/(noise1.*eye(antenna_BS)+(Q*eta_opt*real(trace(sum(Pu_opt,3))))*sum(B_m2(:,:,i+1:M),3));
        %    u_m1(:,:,i)=u_m(:,:,i)/norm(u_m(:,:,i));
        %  end
    
        result(1,1)=max(result00);    
        result(2,1)=UL;
        result1=DL;
        result0=[result;result1;count0];
        parsave(num,result0,flag_error);
    end
   [rate] = parload(loop);
    location = find(rate(1,:));
    final_result(1,p)= mean(rate(1,location));
    location = find(rate(2,:));
    final_result(2,p)= mean(rate(2,location));
    location = find(rate(3,:));
    final_result(3,p)= mean(rate(3,location));
    location = find(rate(4,:));
    final_result(4,p)= mean(rate(4,location));
end

figure(2);
% plot(Power,P_SR_NOMA,'-BO',Power,P_NOMA,'-R*',Power,P_SR_OMA,'-g>');
plot(Power,final_result(1,:),'-R*');
xlabel('$P$_\rm{max}(dBm)')
ylabel('Weighted sum rate (BPCU)')
% legend('Symbiotic NOMA','BackCom-NOMA','Symbiotic-OMA')
legend('BackCom-NOMA');